<dx-popup [(visible)]='gasVisible' width='91vw' height='ds.isMob ? 91vw : auto' [position]="ds.popupPosition" (onHidden)="onPopupHidden($event)">
    <div *dxTemplate="let data of 'title'">
        <div class="logo-small" style="float:left">
            <img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
        </div>
        <h4>Gas Station Order</h4>
    </div>
    <div *dxTemplate="let data of 'content'">
        <dx-form #gasForm [colCount]="1" [formData]='gs' [showValidationSummary]="false" validationGroup="gsValidation">

            <dxi-item itemType="group" [colCount]='3'>
                <dxi-item [label]="{text: 'Station'}" dataField="stationId" editorType="dxSelectBox" [editorOptions]="{ dataSource: dsStation, displayExpr: 'name', onValueChanged: onStationChanged }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Ship To'}" dataField="addressDesc" editorType="dxTextBox" [editorOptions]="{ readOnly: true }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Plant'}" dataField="depotId" editorType="dxSelectBox" [editorOptions]="{ dataSource: dsDepot, valueExpr: 'id', displayExpr: 'name', onValueChanged: onDepotChanged }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
            </dxi-item>

            <dxi-item itemType="group" [colSpan]="1" [colCount]='3'>
                <dxi-item *ngIf='!gs.selTranspVisible || ds.isTrans()' itemType="empty"></dxi-item>
                <dxi-item *ngIf='gs.selTranspVisible && !ds.isTrans()' [label]="{text: 'Transporter'}" dataField="transporterId" editorType="dxSelectBox"
                    [editorOptions]="{ dataSource: dsTransporter, valueExpr: 'id', displayExpr: 'name' }">
                    <dxi-validation-rule type="required"></dxi-validation-rule>
                </dxi-item>
                <dxi-item [label]="{text: 'Range'}" dataField="rangeId" editorType="dxTextBox" [editorOptions]="{ readOnly: true }"></dxi-item>
                <dxi-item *ngIf='!gs.selTranspVisible || ds.isTrans()' [label]="{text: 'Loading Date'}" dataField="requestDate" editorType="dxDateBox"
                    [editorOptions]="{ displayFormat: 'dd.MM.yyyy', width: '100%', readOnly: true }">
                    <dxi-validation-rule type='required'></dxi-validation-rule>
                </dxi-item>
                <dxi-item *ngIf='gs.selTranspVisible && !ds.isTrans()' [label]="{text: 'Loading Date'}" dataField="requestDate" editorType="dxDateBox"
                    [editorOptions]="{ displayFormat: 'dd.MM.yyyy', width: '100%' }">
                    <dxi-validation-rule type='required'></dxi-validation-rule>
                </dxi-item>
            </dxi-item>
            
            <dxi-item itemType="group" [colSpan]="1" [colCount]="1">
                <dxi-item [label]="{text: 'Comments'}" dataField="comments" editorType="dxTextBox" [editorOptions]="">
                    <dxi-validation-rule *ngIf="gs.unloadedId" type='required'></dxi-validation-rule>
                </dxi-item>
            </dxi-item>

        </dx-form>

        <dx-data-grid #gridGasStation [columnAutoWidth]='true' [rowAlternationEnabled]='ds.rowAlternationEnabled' [showColumnLines]='ds.showColumnLines'
            [showRowLines]='ds.showRowLines' height='auto' style="margin-top:10px">

            <dxo-editing mode="cell" [allowUpdating]="true"></dxo-editing>

            <dxi-column caption='Tank' dataField='codes' dataType='string' [allowEditing]='false'></dxi-column>
            <dxi-column caption='Materials' dataField='p_name' dataType='string' [allowEditing]='false'></dxi-column>
            <dxi-column caption='Stock Days' dataField='days' dataType='number' [allowEditing]='false'></dxi-column>
            <dxi-column caption='Daily sales' dataField='daily' dataType='number' [allowEditing]='false'></dxi-column>
            <dxi-column caption='Stock' dataField='stock' dataType='number' [allowEditing]='false'></dxi-column>
            <dxi-column caption='Stock Date' dataField='stockDate' dataType='date' calculateSortValue='stockDate' [calculateDisplayValue]='ds.getDate'
                [allowEditing]='false'></dxi-column>
            <dxi-column caption='Capacity' dataField='capacity' dataType='number' [allowEditing]='false'></dxi-column>
            <dxi-column caption='Max Quantity' [calculateCellValue]='getMaxQuantity' dataType='number' [allowEditing]='false'></dxi-column>
            <dxi-column cssClass="orderColumn" caption='Order' dataField="order" dataType='number' [allowEditing]="true">
                <!-- <dxi-validation-rule type="custom" [validationCallback]="onValidationCallback" message="The order must be positive"></dxi-validation-rule> -->"
                <dxi-validation-rule type='range' min='0' message='The order must be positive'></dxi-validation-rule>
                <dxi-validation-rule *ngIf='gs.loadedQuantity' type='range' [max]='gs.loadedQuantity' message='The order must be less then loaded quantity'></dxi-validation-rule>
            </dxi-column>
            <dxi-column caption='Unit' dataType='string' cellTemplate='unit' [allowEditing]='false'>
                <div *dxTemplate="let data of 'unit'">L15</div>
            </dxi-column>
        </dx-data-grid>

        <div style="float: right;margin:10px 0 20px">
            <dx-button type='success' text='Save' (onClick)='saveGS($event)' validationGroup="gsValidation"></dx-button>
            <dx-button class='redTxt' text='Cancel' (onClick)='cancelGS($event)'></dx-button>
        </div>
    </div>
</dx-popup>